package inline;

import inline.ui.*;
import inline.fs.*;
import inline.sys.*;  
import java.util.*;
import java.lang.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.media.*;
import javax.microedition.media.control.*;
import inline.ui.ce.*;
import inline.ui.lo.*;
import inline.ui.le.*;

// phone 
// - font hei = 19
// - max screen height = 204

// todos: 
// - what to do with JOY.CENTER clicks after 3 secs of play? 
//    now - stop & play again, poss: stop, pause - or next?
// 

// PROBLEMS:
//
// timing in MIDI - incorrect, check output

public class InPlayer extends HostCanvas implements PlayerListener
{
    // some events
    private static final int TIME_TOGO = 0x53B0553C;
    private static final int UPDATE_PLAYLIST = 0xECDF2B31;
    private static final int TTT_REFRESH_SCREEN = 0x89FF0187;
    private static final int TTT_BACKGROUND_RESTARTPLAY = 0x89FF0298;
    private static final int TTT_LOCK_SCREEN_ON = 0xEF734701;
    
    private Player jpl;
    private InList list;
    private Label lMusicInfo;
    private Figure fMark;
    private Label lTime;
    private Figure fPlaymode;
    private Progress pPlayed;
    private Label lVolume;
    private Timer playertimer;
    private boolean playlist_valid;
    private boolean continues;
    private PlaylistElement currenttrack;
    private long ct_startedat;
    private StringElement ceMarkAsNew;
    private StringElement ceMarkAsPlayed;
    private StringElement ceMarkAllAsNew;
    private String lastPlayedFilename;
    private Clock cClock;
    private boolean playamspaused;
    private int playamsidx;
    private int stoppedidx;
    private InPlayerLockScreen lockscreen;
    private Timer lockscreentimer;
    private boolean autoplaycheck = true;
    private Hashtable musicinfo;

    // option names

    public InPlayer(MIDlet midlet)
    {
        setFullScreenMode(true);
	Base.startup(midlet);

	createGUIElements();
	randomizeColorSchemeOnNewInstallation();

	playlist_valid = false;

	Base.setCurrentDisplay(this);
    }

    private void createGUIElements()
    {
	Panel mil = getLayoutManager().addPane(Panel.ALIGN_TOP);

	lMusicInfo = new Label(this, "");
	lMusicInfo.setAutoScroll(true);
//	lMusicInfo.setVisible(false);
lMusicInfo.hasBorder(true);
	addElement(lMusicInfo, mil);

	Panel bil = getLayoutManager().addPane(Panel.ALIGN_BOTTOM);

	fMark = new Figure(this);
	fMark.setFigure(fPlaymode.FIGURE_MARKS);
	fMark.hasBorder(true);
	addElement(fMark, bil, fMark.getFontHeight(),0);

	lVolume = new Label(this, "");
	lVolume.hasBorder(true);
	lVolume.setAlign(Label.CENTER);
	addElement(lVolume,bil);

	cClock = new Clock(this);
	cClock.hasBorder(true);
	addElement(cClock,bil);
	
	lTime = new Label(this,  null);
	lTime.hasBorder(true);
	lTime.setAlign(Label.CENTER);
	addElement(lTime, bil);
	
	fPlaymode = new Figure(this);
	fPlaymode.hasBorder(true);
	fPlaymode.setFigure(fPlaymode.FIGURE_SQUARE);
	addElement(fPlaymode, bil, fPlaymode.getFontHeight(),0);
//	addElement(fPlaymode, bil, 40,40);

	Panel bnil = getLayoutManager().addPane(Panel.ALIGN_BOTTOM);

	pPlayed = new Progress(this);
	addElement(pPlayed, bnil, 0, 3);

	Panel cli = getLayoutManager().addPane(Panel.ALIGN_CLIENT);

	list = new InList(this);
//	list.hasBorder(true);
	list.setAutoScroll(true);
        addElement(list, cli);

	focus(list);
	
	arrangeLeftMenu();
    }

    private void randomizeColorSchemeOnNewInstallation()
    {
	if (Base.getOptionIntDefault(CANVAS_BACKGROUND, -1) == -1)
	{
	    // new installation, RMS is empty
	    // it's time to make a little surprise ;-)
	    SetupC sc = new SetupC(this);
	    sc.applyRandomScheme();
	}
    }
    
    private void setLines(Vector evct)
    {
        if (list!=null && evct!=null)
        {
            list.setLines(evct);
            playlist_valid = true;
        }
    }
    
    private void arrangeLeftMenu()
    {
	Vector lm = new Vector();    
	
	ceMarkAsNew = new StringElement(Base.getText(0x0201));
	ceMarkAsPlayed = new StringElement(Base.getText(0x0202));
	ceMarkAllAsNew = new StringElement(Base.getText(0x0203));
	
	lm.addElement(ceMarkAsNew);
	lm.addElement(ceMarkAsPlayed);
	lm.addElement(ceMarkAllAsNew);
	
	this.setMenu(lm, CanvasElement.LEFT_SOFT, Graphics.LEFT|Graphics.BOTTOM);
    }
    
    protected boolean keyPreview(int keyCode)
    {
	if (keyCode == (int)'0')
	{
	    if (jpl!=null)
	    {
		continues = false;
		stoppedidx = list.getLines().indexOf(currenttrack);
		onStop(fPlaymode.FIGURE_PAUSE);
		list.repaint();
	    }
	    else
	    {
		resumeFromStop();
	    }
	}

	if (keyCode == (int)'*')
	{
	    adjustVolume(-1);
	}

	if (keyCode == (int)'#')
	{
	    adjustVolume(1);
	}

	if (keyCode == (int)'4')
	{
	    adjustPosition(-1);
	}

	if (keyCode == (int)'6')
	{
	    adjustPosition(1);
	}

	if (keyCode == (int)'8')
	{
	    if (currenttrack!=null)
	    {
		currenttrack.setPosition(-1);
	    }
	    thinkAboutNext(currenttrack);
	}

	if (keyCode == (int)'1')
	{
	    markSelectedGoNext();
	}

	if (keyCode == (int)'9')
	{
	    showSongInfo();
	}

	if (keyCode == (int)'7')
	{
	    if (jpl != null)
	    {
		setTrackPosition(jpl.getDuration()-3000000);
	    }
	}

	if (keyCode == -23 || keyCode == (int)'3')
	{
	    Menu menu = new Menu(this);
	    menu.focus();
	}
	
	return false;
    }

    public void manageBacklight()
    {
	super.manageBacklight();
       	activateLockScreenTimer();
    }
    
    public void invalidatePlaylist(boolean force)
    {
	if (!playlist_valid || force)
	{
	    try
	    {
		PlaylistInvalidator playlister = new PlaylistInvalidator(this, PlaylistInvalidator.PLAYLIST_LOAD);
		WaitingCanvas wc = new WaitingCanvas(playlister);
		playlister.setParent(wc);
		wc.setCaption(Base.getText(0x0000));
		wc.setOperation(Base.getText(0x0100));
		wc.setTag(UPDATE_PLAYLIST);
		
		Vector tlst = list.getLines();
		if (tlst!=null && tlst.size()>0)
		{
		    storeLastSelection();
		    onStop();
		    playlister.setList(tlst);
		}
		
		wc.perform(this);
	    }
	    catch(Exception e)
	    {
		Log.fire("GetPL: "+e);
	    }
	}
    }
    
    public void selectPreview(Object obj)
    {
	super.selectPreview(obj);
	
	if (obj instanceof PlaylistElement)
	{
	    PlaylistElement pe = (PlaylistElement)obj;
	    if (jpl != null && currenttrack != null &&
		    pe == currenttrack && 
			(currenttrack.getPosition() - ct_startedat)<20000000
		)
	    {
		setTrackPosition(0);
	    }
	    else
	    {
		continues = true;
		onPlay(pe);
		list.repaint();
	    }
	}
	
	if (obj instanceof WaitingCanvas)
	{
	    WaitingCanvas wc = (WaitingCanvas)obj;
	    if (wc.getTag() == TIME_TOGO)
	    {
		// see ya again
		Base.goodbye();
	    }
	    else if (wc.getTag() == UPDATE_PLAYLIST)
	    {
		updatePlaylistDone((PlaylistInvalidator)wc.getRunner());
		
		if (autoplaycheck && Base.getOptionIntDefault(Options.PLAYER_AUTOSTART,0) == 1)
		{
		    thinkAboutNext(null);
		}
		autoplaycheck = false;
	    }

	}
	
	if (obj instanceof StringElement)
	{
	    if (obj == ceMarkAsNew)
	    {
		markAs(1,0);
		menuHide();
	    }
	    else if (obj==ceMarkAsPlayed)
	    {
		markAs(1,-1);
		menuHide();
	    }
	    else if (obj==ceMarkAllAsNew)
	    {
		markAs(0,0);
		menuHide();
	    }
	}
    }

    private void updatePlaylistDone(PlaylistInvalidator pli)
    {
	Vector lst = pli.getList();
	setLines(lst);
		
	// try to restore last filename position
	String lastfn = (String)Base.getOption(Options.PLAYER_LASTFN);
	if (lastfn!=null && lst!=null)
	{
	    for(int i=0;i<lst.size();i++)
	    {
		if (lst.elementAt(i) instanceof PlaylistElement)
		{
		    PlaylistElement ple = (PlaylistElement)lst.elementAt(i);
		    if (ple.getFilename().compareTo(lastfn)==0)
		    {
			list.setSelectedIndex(i);
			break;
		    }
		}
	    }
	}
    }
    
    public void onStop()
    {
	onStop(fPlaymode.FIGURE_SQUARE);
    }

    public void onStop(int state)
    {
System.err.println("==== OnStopS");
        try
        {
	    if (jpl != null &&   
		    jpl.getState() != Player.CLOSED && 
		    jpl.getState() != Player.UNREALIZED)
	    {
		jpl.stop();   
		jpl.deallocate();
		jpl.close();
		jpl = null;
		
		if (currenttrack != null)
		{
		    currenttrack.setSelected(false);
		    currenttrack = null;
		}
	    }
	    
	    setPlayerStateIcon(state);
	    if (state!=fPlaymode.FIGURE_PAUSE)
	    {
		lTime.setCaption(null);
	    }
	    pPlayed.setPosition(0);
	    playertimer = killTimer(playertimer);
	}
        catch(Exception exception)
        {
            Log.fire("onStop() failed:" + exception.getMessage());
        }
	
	System.gc();
	processInfo();
System.err.println("==== OnStopF");
    }
    
    public boolean onPlay(PlaylistElement ple)
    {
	    //String url = "file://sub/town.mid";
System.err.println("==== OnPlayS");
	boolean res = false;    

	String fn = ple.getFilename();
	String url = "file:/" + fn;
	
        try
        {
	    System.gc();
	    onStop(fPlaymode.FIGURE_SPLITRECT);
	    serviceRepaints();
            jpl = null;

	    int cnt = 15;
	    while(true)
	    {
		try
		{
		    // MIDIs need to be created via Stream 
		    // or else it seems to be problem on Motorola E398
		    
		    if (fn.toLowerCase().endsWith(".mid"))       
		    {
			FileAccessible fs = Provider.access();       
			fs.open(fn, Connector.READ);
			jpl = Manager.createPlayer(fs.openInputStream(),"audio/midi");
		    }   
		    else
		    {
			jpl = Manager.createPlayer(url);
		    }

		    jpl.realize();
		    jpl.prefetch();
		    break;
		}
		catch(Exception e)
		{
		    // that's the fix for 'prefetch failed' error in motorola handsets
		    // it happens sometimes, so we need to be ready for it
		    
		    if (e.toString().indexOf("prefetch failed")>=0)
		    {
			cnt--;
			if (cnt>0)
			{
			    Log.fire("jpl_prefetch_error_sleep");		
			    serviceRepaints();
			    Thread.currentThread().sleep(1500);
			    jpl.deallocate();
			    jpl.close();
			    jpl = null;
			}
			else
			{
			    serviceRepaints();
			    Log.fire("Giving up...");		
			    jpl.prefetch();
			}
		    }
		    else
		    {
			serviceRepaints();
			throw e;
		    }
		}
	    }
    
	    processInfo();
	    processVolume();
	    setTrackPosition(ple.getPosition());
    
	    currenttrack = ple;
	    currenttrack.setSelected(true);
	    ct_startedat = ple.getPosition();

            jpl.addPlayerListener(this);
	    jpl.start();

	    setPlayerStateIcon(fPlaymode.FIGURE_TRI_E);
	    
	    playertimer = newFixedRateTimer(playertimer,TTT_REFRESH_SCREEN,0,1000,null);
	    lastPlayedFilename = fn;
	    
	    res = true;
	}
        catch(Exception exception)
        {
            Log.fire("createPlayer failed:" + exception.getMessage()+", file="+url);
	    jpl = null;
	    currenttrack = null;
        }
	
System.err.println("==== OnPlayF");
	return res;
    }

    private void setPlayerStateIcon(int icon)
    {
	fPlaymode.setFigure(icon);
	
	if (lockscreen!=null)
	{
	    lockscreen.setPlayerStateIcon(icon);
	}
    }
    
    private void processInfo()
    {
	String line = "";
	musicinfo = null;
	musicinfo = new Hashtable();
	
	if (jpl != null)
	{
	    try
	    {
		MetaDataControl md = (MetaDataControl)jpl.getControl("MetaDataControl");
		
		musicinfo.put(MetaDataControl.TITLE_KEY, "?");
		musicinfo.put(MetaDataControl.AUTHOR_KEY, "?");

		if (md!=null)
		{
		    String[] abc = md.getKeys();
		    for(int i = 0;i<abc.length;i++)
		    {
			String val = md.getKeyValue(abc[i]).trim();

			// strip the val by first null char encounted			
			int nc = val.indexOf(0);
			if (nc>0)
			{
			    val = val.substring(0, nc).trim();
			}
			
			musicinfo.put(abc[i], Byte2UnicodeDecoder.convert(val));
		    }
		      
		}  
		
		line = (musicinfo.get(MetaDataControl.AUTHOR_KEY) + " - " + 
			musicinfo.get(MetaDataControl.TITLE_KEY));
	    }

	    catch(Exception e)
	    {
		Log.fire("processInfo failed:" + e);  
	    }
	}
	
/*	if (line.length()==0 && lMusicInfo.isVisible() ||
	    line.length()!=0 && !lMusicInfo.isVisible())
	    {
		lMusicInfo.setVisible(line.length()!=0);
		reLayout();
	}*/

	lMusicInfo.setCaption(line);
	lMusicInfo.repaint();

    	if (lockscreen!=null)
	{
	    lockscreen.setMusicInfo(musicinfo);
	}
    }

    private void processVolume()
    {    
	int vol = Base.getOptionIntDefault(Options.PLAYER_VOLUME, 70);
	
	if (jpl != null)
	{
	    try
	    {
                VolumeControl vc = (VolumeControl)jpl.getControl("VolumeControl");
		if (vc!=null)
		{
		    vc.setMute(false);
		    vc.setLevel(vol);
		}
	    }

	    catch(Exception e)
	    {
		Log.fire("processVolume failed:" + e);
	    }
	}   
	
	lVolume.setCaption(new Integer(vol).toString()+"%");
    }

    private void setTrackPosition(long pos)
    {    
	if (jpl != null)
	{
	    try
	    {
		if (pos!=-1)
		{
		    jpl.setMediaTime(pos);
		}
	    }

	    catch(Exception e)
	    {
		Log.fire("setTrackPosition failed:" + e);
	    }
	}   
    }

    private void adjustVolume(int delta)
    {
	int current = Base.getOptionIntDefault(Options.PLAYER_VOLUME, 70);

	current += delta*10;
	if (current<0) current = 0;
	if (current>100) current = 100;
	
	Base.putOptionInt(Options.PLAYER_VOLUME,current);
	
	processVolume();
    }

    private void adjustPosition(long flag)
    {
	if (jpl != null)   
	{
	    long jplt = jpl.getMediaTime();
	    long jpld = jpl.getDuration();
	    
	    int fstep = Base.getOptionIntDefault(Options.PLAYER_FORWARDSTEP,5);
	    long stepval = 0; // msec
	    
	    if (fstep<100) 
	    {
		stepval = fstep*jpld/100;
	    }
	    else
	    {
		stepval = (fstep-100)*1000000; 
	    }
	    
	    long npos = jplt + flag*stepval;
	    if (npos>jpld) npos = jpld - 1000; // end - 1 sec
	    if (npos<0) npos = 0;

	    setTrackPosition(npos);
	}
    }
    
    public void onTimer(int tag, long delta, Object object)
    {
	super.onTimer(tag, delta, object);
	
	boolean timerok = (delta < 300); // 300 msecs ought to be... you know
	
	if ((tag == TTT_REFRESH_SCREEN) && (jpl!=null) && timerok)
	{
	    timerRefreshScreen();
	}
	else if (tag == TTT_BACKGROUND_RESTARTPLAY)
	{
	    if (timerok && jpl == null && playamspaused)
	    {
		restartPlayback();
	    }
	}
	else if (tag == TTT_LOCK_SCREEN_ON && delta<1000 && this.isShown())
	{
	    displayLockScreen(false);
	}
    }

    private void timerRefreshScreen()
    {
	    long jplt = jpl.getMediaTime();
	    long jpld = jpl.getDuration();
	    int mt = (int)((jpld-jplt)/1000000);
	    int min = mt/60;
	    int sec = mt % 60;
		    
	    String ms = new Integer(min).toString();
	    if (ms.length()==1) ms = "0"+ms;
	    String ss = new Integer(sec).toString();
	    if (ss.length()==1) ss = "0"+ss;

	    lTime.setCaption(ms+":"+ss);
	    pPlayed.setPosition((int)(100*jplt/jpld));

	    if (currenttrack!=null)
	    {
		long pp = currenttrack.getPosition();
		currenttrack.setPosition(jplt);
		if ((pp==0 || pp==-1) && jplt!=0)
		{
		    list.repaint();
		}
	    }
    }
    
    public void playerUpdate(Player player, String event, Object obj)
    {
	// discard expired players
	if (jpl == null || player!=jpl) return;
	
	if (event.compareTo("endOfMedia")==0)
	{
	    PlaylistElement hple = currenttrack;
	    
	    if (currenttrack!=null)
	    {
		currenttrack.setPosition(-1);
		list.repaint();
	    }

	    onStop();
	    currenttrack = null;

	    thinkAboutNext(hple);
	}
    }

    private void thinkAboutNext(PlaylistElement hple)
    {
	Vector lines = list.getLines();

	// get current index
	int idx = -1;
	if (hple != null) idx = lines.indexOf(hple);
	if (idx == -1) idx = list.getSelectedIndex();

	int aidx = -1;
	
	Vector availelms;

	// find next track
	while(true)
	{
	    // create available tracks list
	    availelms = null;
	    availelms = new Vector();
	    boolean sf = false;
	    for(int i = 0;i<lines.size();i++)
	    {
		PlaylistElement ple = (PlaylistElement)lines.elementAt(i);
		if (aidx == -1 && idx == i) sf = true;
		if (ple.getPosition() != -1)  
		{
		    availelms.addElement(ple);
		    if (sf)
		    {
			aidx = availelms.size() - 1;
			sf = false;
		    }
		}

	    }

	    if (availelms.size() == 0) // all played
	    {
		Log.fire("All played, loop stopped");
	        break;
	    }

	    // shift logic
	    if (Base.getOptionIntDefault(Options.PLAYER_SHUFFLE, 0) == 1)
	    {
		aidx = (new Random().nextInt() & 0xfffff) % availelms.size();
	    }
	    else
	    {
		if (aidx<0 || aidx>=availelms.size()) aidx = 0;
	    }

	    // try it
	    PlaylistElement ple = (PlaylistElement)availelms.elementAt(aidx);
	    if (ple.getPosition() != -1)
	    {
		if (onPlay(ple)) break;
		
		// something wrong (CreatePlayer failed)
		// try next track
		ple.setPosition(-1);   
		list.repaint();
	    }

	}
	
	list.repaint();
    }

    private void markAs(int what, int pos)
    {
	Vector markedple = new Vector();
	
	if (what==1)
	{
	    for(int i=0;i<list.getLines().size();i++)
	    {
		PlaylistElement ple = (PlaylistElement)list.getLines().elementAt(i);
		if (ple.isMarked())
		{
		    markedple.addElement(ple);
		    ple.invertMarked();
		}
	    }

	    if (markedple.size()==0)
	    {
		markedple.addElement(list.getSelectedElement());
	    }  
	}
	else
	{
	    markedple = list.getLines();  
	}
	 
	for(int i=0;i<markedple.size();i++)
	{
	    PlaylistElement ple = (PlaylistElement)markedple.elementAt(i);
	    ple.setPosition(pos);
	}
	
	list.repaint();
    }
    
    private void storeLastSelection()
    {
	String storefn = null; 
	
	if (currenttrack != null) // remember last played track, if we're playing it
	{
	    storefn = currenttrack.getFilename();
	}
	else      
	{
	    if (lastPlayedFilename!=null) // remember last played track
	    {
		storefn = lastPlayedFilename;
	    }
	    else // or else store selection filename
	    {
		Object obj = list.getSelectedElement();
		if (obj!=null && obj instanceof PlaylistElement)
		{
		    PlaylistElement ple = (PlaylistElement)obj;
		    storefn = ple.getFilename();
		}
	    }
	}

//System.err.println("StoreFN: "+storefn);	
	
	if (storefn!=null)
	{
	    Base.putOption(Options.PLAYER_LASTFN,storefn);
	}
    }
    
    public String getLastPlayedFilename()
    {
	return lastPlayedFilename;
    }
    
    public void graceExit()
    {
	storeLastSelection();
	
	onStop();
	Base.saveOptions();

	PlaylistInvalidator playlister = new PlaylistInvalidator(this, PlaylistInvalidator.PLAYLIST_SAVE);
	playlister.setList(list.getLines());
	WaitingCanvas wc = new WaitingCanvas(playlister);
	playlister.setParent(wc);
	wc.setCaption(Base.getText(0x0000));
	wc.setOperation(Base.getText(0x0101));
	wc.setTag(TIME_TOGO);
	wc.perform(this);
    }

    private void restartPlayback()
    {
	// restore playback after pause
        PlaylistElement ple = (PlaylistElement)list.getLines().elementAt(playamsidx);
	if (ple!=null)
	{
	    onPlay(ple);
	}
	playamspaused = false;
    }
    
    public void startapp()
    {
System.err.println("==== StartApp");
	int bgs = Base.getOptionIntDefault(Options.PLAYER_BACKGROUND,0);
	
	if (playamspaused)
	{
	    if (bgs==1) 
	    {
		newSingleShotTimer(null, TTT_BACKGROUND_RESTARTPLAY, 800, null);
	    }
	    else
	    {
		restartPlayback();
	    }
	}
	else   
	{
	    invalidatePlaylist(false);
	}

	// turn off backlight if AMS switched me on again and
	// lockscreen is active
	if (lockscreen!=null && getLastVisible()==lockscreen)
	{
	    lockscreen.turnOffBacklightOnNextShow();
	}
    }

    public void pauseapp()
    {
System.err.println("==== PauseApp");
	if (jpl != null)
	{
	    playamspaused = true;
	    playamsidx = list.getLines().indexOf(currenttrack);
	    onStop(fPlaymode.FIGURE_PAUSE);
	}
    }

    private void resumeFromStop()
    {
	PlaylistElement ple = (PlaylistElement)list.getLines().elementAt(stoppedidx);
	boolean ok = false;
	if (ple!=null)
	{
	    if (ple.getPosition()!=-1)
	    {
		ok = onPlay(ple);
	    }
	    
	    if (!ok)
	    {
		thinkAboutNext(ple);
	    }
	}
    }

    public void displayLockScreen(boolean manual)
    {
	clearLockScreenTimer();
	if (lockscreen!=null) lockscreen=null;
	lockscreen = new InPlayerLockScreen(this);
	lockscreen.setPlayerStateIcon(fPlaymode.getFigure()); 
	lockscreen.setMusicInfo(musicinfo);
	lockscreen.focus();
	
	if (manual)
	{
	    turnOffBacklight();
	}
	
    }

    private void activateLockScreenTimer()
    {
	clearLockScreenTimer();
	
	int to = Base.getOptionIntDefault(Options.LOCKSCREEN_AUTO,0);
	int fo = Base.getOptionIntDefault(CANVAS_FLASHOFF,30);

	if (to>0 && fo>0)
	{
	    lockscreentimer = newSingleShotTimer(lockscreentimer, 
				TTT_LOCK_SCREEN_ON, 
				1000 * (to+fo), 
				null);
	}
    }
    
    private void clearLockScreenTimer()
    {
	playertimer = killTimer(lockscreentimer);
    }
    
    private void showSongInfo()
    {
	String info = lastPlayedFilename+"\n";
	
	if (musicinfo==null) return;
	if (musicinfo.size()==0) return;
	
        String ks[] = new String[musicinfo.size()];
	int i=0;
	for (Enumeration e = musicinfo.keys() ; e.hasMoreElements() ;) 
	{
	    ks[i] = (String)e.nextElement();
	    i++;
	}

	Base.sortStringArray(ks);
	
	for(i=0;i<ks.length;i++)
	{
	    info += ks[i] + ": " + (String)musicinfo.get(ks[i])+"\n";
	}
	
	InfoListCanvas ibc = new InfoListCanvas(this, Base.getText(0x0801), info );
	focus(ibc);
    }
    
    private void markSelectedGoNext()
    {
	ListElement le = list.getSelectedElement();
	if (le instanceof PlaylistElement)
	{
	    PlaylistElement ple = (PlaylistElement)le;
	    ple.invertMarked();
	    list.moveSelectionDown();
	    list.repaint();
	}
    }
}
