package inline;

import inline.ui.*;
import inline.fs.*;
import inline.sys.*;
import java.util.*;
import java.lang.*;
import inline.ui.ce.*;
import inline.ui.lo.*;
import inline.ui.le.*;
import javax.microedition.media.control.*;

public class InPlayerLockScreen extends LockScreen
{
    public static final int COLOR_BW = 0;
    public static final int COLOR_WB = 1;
    public static final int COLOR_NATIVE = 2;
    
    private Figure fPlaymode;
    private Label lMusicInfoTitle;
    private Label lMusicInfoAuthor;
    private StringElement seNext;
    private StringElement seStop;
    private StringElement seBack;
    private boolean turnoffbacklightonnextshow;

    public InPlayerLockScreen(InPlayer ip)
    {
	super(ip);
	
	seNext = new StringElement(Base.getText(0x0701));
	seNext.setAccelerator('8');
	seStop = new StringElement(Base.getText(0x0702));
	seStop.setAccelerator('0');
	seBack = new StringElement(Base.getText(0x0703));
	seBack.setAccelerator('*');
	
	Vector lst = new Vector();
	lst.addElement(seNext);
	lst.addElement(seStop);
	lst.addElement(seBack);
	
	setMenu(lst);
	
	int colors = Base.getOptionIntDefault(Options.LOCKSCREEN_COLORS,0);
	
	if (colors==COLOR_BW)
	{
	    setBackgroundColor(0xffffff);
	    setForegroundColor(0x0);
	}
	else if (colors==COLOR_WB)
	{
	    setBackgroundColor(0x0);
	    setForegroundColor(0xffffff);
	}

    }

    protected void createGUIElements()
    {
	Panel bil = getLayoutManager().addPane(Panel.ALIGN_BOTTOM);

	Figure fMark = new Figure(this);
	fMark.setFigure(fMark.FIGURE_LOCK);
	addElement(fMark, bil, fMark.getFontHeight(),0);

	lMusicInfoTitle = new Label(this, "");
	addElement(lMusicInfoTitle, bil);

	Panel bbil = getLayoutManager().addPane(Panel.ALIGN_BOTTOM);

	fPlaymode = new Figure(this);
	addElement(fPlaymode, bbil, fPlaymode.getFontHeight(),0);

	lMusicInfoAuthor = new Label(this, "");
	addElement(lMusicInfoAuthor, bbil);

	super.createGUIElements();
    }

    public void setPlayerStateIcon(int icon)
    {
	fPlaymode.setFigure(icon);
	
    }

    public void setMusicInfo(Hashtable musicinfo)
    {
	if (musicinfo!=null)  
	{
	    lMusicInfoAuthor.setCaption((String)musicinfo.get(MetaDataControl.AUTHOR_KEY));
	    lMusicInfoTitle.setCaption((String)musicinfo.get(MetaDataControl.TITLE_KEY));

	    lMusicInfoAuthor.repaint();
	    lMusicInfoTitle.repaint();
	}
    }
    
    public void selectPreview(Object obj)
    {
	super.selectPreview(obj);
	
	if (obj == seBack)
	{
	    goBack(true);
	}
	else if (obj == seNext || obj == seStop)
	{
	    InPlayer ip = (InPlayer)getPrevious();
	    StringElement se = (StringElement)obj;
	    menuHide();
	    ip.keyPreview(se.getAccelerator());
	}
    }
    
    public void turnOffBacklightOnNextShow()
    {
	turnoffbacklightonnextshow = true;
    }
    
    public void showNotify()
    {
	super.showNotify();
	
	if (turnoffbacklightonnextshow)
	{
	    // we can't do it ourself, because we're BacklightInsensible;
	    // ask parent instead
	    getPrevious().turnOffBacklight();
	}
	
	turnoffbacklightonnextshow = false;
    }
    
    public void keyPressed(int keyCode)
    {
	super.keyPressed(keyCode);
	
	int backlight = Base.getOptionIntDefault(Options.LOCKSCREEN_BACKLIGHT,0);
	if (backlight>0)
	{
	    getPrevious().manageBacklight(backlight);
	}
    }
    
    
}

