package inline;

import inline.ui.*;
import inline.sys.*;
import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import inline.ui.le.*;
import inline.ui.ce.*;

// phone 
// - font hei = 19
// - max screen height = 204

public class Menu extends ListFormCanvas 
{
    private InPlayer player;
    private FigureElement seOptionsU;
    private FigureElement seOptionsP;
    private StringElement seTextEdit;
    private StringElement seReloadPlaylist;
    private StringElement seLock;
    private StringElement seLog;
    private StringElement seAbout;
    private StringElement seQuit;
    
    public Menu(InPlayer pplayer)
    {
	super(pplayer, Base.getText(0x0401), "", Base.getText(0x0505));
	player = pplayer;
		
	seOptionsU = new FigureElement(Base.getText(0x0402), CanvasElement.FIGURE_RARROW);
	seOptionsP = new FigureElement(Base.getText(0x0403), CanvasElement.FIGURE_RARROW);
	seLock = new StringElement(Base.getText(0x0404));
	seLock.setAccelerator('*');
	seReloadPlaylist = new StringElement(Base.getText(0x0405));
	seLog = new StringElement(Base.getText(0x0406)+"...");
	seAbout = new StringElement(Base.getText(0x0411)+"...");
	seQuit = new StringElement(Base.getText(0x0407));   

	makemenu(false);
    }
	
    private void makemenu(boolean reloadvisforce)
    {
	int psel = list.getSelectedIndex();
	
	Vector vct = new Vector();
	vct.addElement(seOptionsU);
	vct.addElement(seOptionsP);
	vct.addElement(seLock);
	
	if (reloadvisforce || Base.getOptionIntDefault(Options.PLAYER_MEMORYFIRST,0)!=0)
	{
	    vct.addElement(seReloadPlaylist);
	}
	vct.addElement(seLog);
	vct.addElement(seAbout);
	vct.addElement(seQuit);

	list.setLines(vct);
	list.setFastScroll(false);
	list.assignNumberAccelerators();
	list.setSelectedIndex(psel);
    
    }
            
    public void remakeMenu(boolean reloadvisforce)
    {
	makemenu(reloadvisforce);
    }
    
    public void selectPreview(Object obj)
    {
	super.selectPreview(obj);
	
	if (obj instanceof ListElement)
	{
	    if (obj == seQuit)
	    {
		player.graceExit();
	    }
	    else if (obj == seOptionsU)
	    {
		SetupU stp = new SetupU(player, this);
		focus(stp);
	    }
	    else if (obj == seOptionsP)
	    {
		SetupP stp = new SetupP(this);
		focus(stp);
	    }
	    else if (obj == seLock)  
	    {
		player.displayLockScreen(true);
	    }
	    else if (obj == seReloadPlaylist)
	    {
		player.invalidatePlaylist(true);
	    }
	    else if (obj == seLog)
	    {
		InfoListCanvas ibc = new InfoListCanvas(this, Base.getText(0x0406), Log.getString() );
		focus(ibc);
	    }
	    else if (obj == seAbout)
	    {
		InfoListCanvas ibc = new InfoListCanvas(this, Base.getText(0x0411), 
					    Base.getText(0x0000) + " " + Base.getVersion()+"\n" + 
					    Base.getText(0x0413) + "\n" +
					    Base.getText(0x0412)  );
		focus(ibc);
	    }
	}
    }

}

