package inline;

import inline.ui.*;
import inline.ui.le.CheckElement;


public class PlaylistElement extends CheckElement 
{
    private String fullpath;
    
    // position - 0 - not played
    // 1.... - part of file played 
    // -1 - file played completely
    private long position;
        
    public PlaylistElement(String fpath)
    {
	super(fpath,TYPE_3);
	
        fullpath = fpath;
	position = 0;
            
        int si = text.lastIndexOf('/');
        text = text.substring(si+1);

        int pi = text.lastIndexOf('.');
        if (pi>0)
        {
	    text = text.substring(0, pi);
	}
    }
     
    public String getFilename()
    {
	return fullpath;
    }
    
    public void updateState()
    {
	if (position == 0)
	{
	    state = 0;
	}
	else if (position == -1)
	{
	    state = 1;
	}
	else
	{
	    state = 2;
	}
    }
    
    public long getPosition()
    {
	return position;
    }
    
    public void setPosition(long ppos)
    {
	position = ppos;
	updateState();
    }

    public boolean onSelect()
    {
        return false;
    }
    
}
