package inline;

import inline.ui.*;
import inline.sys.*;
import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import inline.ui.le.*;
import inline.ui.ce.*;

public class SetupLS extends ListFormCanvas 
{
    private CheckElement seSeconds;
    private ChoiceElement ceAutolock;
    private ChoiceElement ceColors;
    private ChoiceElement ceBacklight;
    
    public SetupLS(HostCanvas pprevious)
    {
	super(pprevious, Base.getText(0x0438), Base.getText(0x0504), Base.getText(0x0505));
	
	seSeconds = new CheckElement(Base.getText(0x0704),CheckElement.TYPE_2);
	seSeconds.setState(Base.getOptionIntDefault(Options.LOCKSCREEN_SECONDS,0));

	String sec = Base.getText(0x0451);
	String min = Base.getText(0x0452);

	String[] als = {Base.getText(0x0503), "5 "+sec, "15 "+sec, "30 "+sec, "1 "+min, "2 "+min, "5 "+min};
	int[] alp = {0,5,15,30,60,120,300};
	ceAutolock = new ChoiceElement(Base.getText(0x0705),
					    als,
					    alp,
					    Base.getOptionIntDefault(Options.LOCKSCREEN_AUTO,0));

	String[] acs = {Base.getText(0x0707), Base.getText(0x0708), Base.getText(0x0709) };
	int[] acp = {0,1,2};
	ceColors = new ChoiceElement(Base.getText(0x0706),
					    acs,
					    acp,
					    Base.getOptionIntDefault(Options.LOCKSCREEN_COLORS,0));
	
	String[] bts = {Base.getText(0x0503), "1 "+sec, "2 "+sec, "3 "+sec, "5 "+sec, "10 "+sec};
	int[] btp = {0,1,2,3,5,10};
	ceBacklight = new ChoiceElement(Base.getText(0x0432),
					    bts,
					    btp,
					    Base.getOptionIntDefault(Options.LOCKSCREEN_BACKLIGHT,0));

	Vector vct = new Vector();
	vct.addElement(seSeconds);
	vct.addElement(ceAutolock);   
	vct.addElement(ceBacklight);
	vct.addElement(ceColors);
	
	list.setLines(vct);
	list.setFastScroll(false);
    }
            
    protected void submit()
    {
	Base.putOptionInt(Options.LOCKSCREEN_SECONDS,seSeconds.getState());
	Base.putOptionInt(Options.LOCKSCREEN_AUTO,ceAutolock.getSelectedKey());
        Base.putOptionInt(Options.LOCKSCREEN_COLORS,ceColors.getSelectedKey());
        Base.putOptionInt(Options.LOCKSCREEN_BACKLIGHT,ceBacklight.getSelectedKey());

	super.submit();
    }
    
}



