package inline;

import inline.ui.*;
import inline.sys.*;
import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import inline.ui.le.*;
import inline.ui.ce.*;
import inline.ui.SetupStringArrayEditor;

public class SetupP extends ListFormCanvas 
{
    private CheckElement ceShuffle;
    private CheckElement ceSubdirs;
    private CheckElement cePUpdate;
    private CheckElement ceAutostart;
    private CheckElement ceBackground;
    private CheckElement ceStatusSaveC;
    private ChoiceElement ceStatusSaveP;
    private StringElement seExts;
    private StringElement seDirs;
    private StringElement sePlm;
    private ChoiceElement seForwardStep;
    private SetupStringArrayEditor ssaeDirs;
    
    public SetupP(HostCanvas pprevious)
    {
	super(pprevious, Base.getText(0x0403), Base.getText(0x0504), Base.getText(0x0505));
	
	seExts = new FigureElement(Base.getText(0x0423), CanvasElement.FIGURE_RARROW);
	seDirs = new FigureElement(Base.getText(0x0424), CanvasElement.FIGURE_RARROW);
	ceShuffle = new CheckElement(Base.getText(0x0421),CheckElement.TYPE_2);
	ceShuffle.setState(Base.getOptionIntDefault(Options.PLAYER_SHUFFLE,0));
	
	ceSubdirs = new CheckElement(Base.getText(0x0422),CheckElement.TYPE_2);
	ceSubdirs.setState(Base.getOptionIntDefault(Options.PLAYER_SUBDIRS,0));
	
	cePUpdate = new CheckElement(Base.getText(0x0425),CheckElement.TYPE_2);
	cePUpdate.setState(Base.getOptionIntDefault(Options.PLAYER_MEMORYFIRST,0));
	
	sePlm = new StringElement((String)Base.getOption(Options.PLAYER_PLAYLISTMEMORY));
	
	ceAutostart = new CheckElement(Base.getText(0x0427),CheckElement.TYPE_2);
	ceAutostart.setState(Base.getOptionIntDefault(Options.PLAYER_AUTOSTART,0));
	    
	ceBackground = new CheckElement(Base.getText(0x0428),CheckElement.TYPE_2);
	ceBackground.setState(Base.getOptionIntDefault(Options.PLAYER_BACKGROUND,0));

	ceStatusSaveC = new CheckElement(Base.getText(0x042B),CheckElement.TYPE_2);
	ceStatusSaveC.setState((Base.getOptionIntDefault(Options.PLAYER_SAVESTATUSES,3)>0) ? 1:0);

	String[] pss = {Base.getText(0x042D),
			Base.getText(0x042E),
			Base.getText(0x042F)};
	int[] psp = {1,2,3};
	ceStatusSaveP = new ChoiceElement(Base.getText(0x042C),
					    pss,
					    psp,
					    Base.getOptionIntDefault(Options.PLAYER_SAVESTATUSES,3));

	String sec = Base.getText(0x0451);
	
	String[] fss = {"1%","2%","3%", "5%", "10%", "20%", "5 "+sec, "10 "+sec, "15 "+sec, "30 "+sec};
	int[] fsp = {1,2,3,5,10,20,105,110,115,130};
	seForwardStep = new ChoiceElement(Base.getText(0x0430),
					    fss,
					    fsp,
					    Base.getOptionIntDefault(Options.PLAYER_FORWARDSTEP,5));
	
	
	Vector vct = new Vector();
	vct.addElement(seExts);
	vct.addElement(seDirs);
	vct.addElement(ceSubdirs);
	vct.addElement(ceShuffle);
	vct.addElement(ceAutostart);
	vct.addElement(ceBackground);

	vct.addElement(new StringElement(Base.getText(0x0426)));
	vct.addElement(sePlm);
	vct.addElement(cePUpdate);
	vct.addElement(new StringElement(Base.getText(0x0429)));
	vct.addElement(ceStatusSaveC);
	vct.addElement(ceStatusSaveP);
	vct.addElement(seForwardStep);
	
	list.setLines(vct);
	list.setFastScroll(false);
    }
            
    public void selectPreview(Object obj)
    {
	super.selectPreview(obj);
	
	if (obj instanceof ListElement)
	{
	    if (obj == seExts)
	    {
		SetupStringArrayEditor se = new SetupStringArrayEditor(this, Base.getText(0x0423), 
					    Options.PLAYER_EXTENSIONS, Options.PLAYER_EXTENSIONFLAGS, ".");
		focus(se);
	    }
	    else if (obj == seDirs)
	    {
		ssaeDirs = new SetupStringArrayEditor(this, Base.getText(0x0424), 
					    Options.PLAYER_DIRECTORIES, Options.PLAYER_DIRECTORYFLAGS, "/");
		focus(ssaeDirs);
	    }
	    else if (obj == sePlm)
	    {
		TextEditCanvas tec = new TextEditCanvas(this, sePlm.getString());
		focus(tec);
	    }
	}
	
	if (obj instanceof TextEditCanvas)
	{
	    TextEditCanvas tec = (TextEditCanvas)obj;
	    sePlm.setString(tec.getText().toLowerCase());
	}
	
	if (obj == ssaeDirs)
	{
	    Menu mnu = (Menu)getPrevious();
	    mnu.remakeMenu(true);
	}
    }

    protected void submit()
    {
	Base.putOptionInt(Options.PLAYER_SHUFFLE,ceShuffle.getState());
	Base.putOptionInt(Options.PLAYER_SUBDIRS,ceSubdirs.getState());
	Base.putOptionInt(Options.PLAYER_MEMORYFIRST,cePUpdate.getState());
	Base.putOptionInt(Options.PLAYER_AUTOSTART,ceAutostart.getState());
	Base.putOptionInt(Options.PLAYER_BACKGROUND,ceBackground.getState());
	
	Base.putOptionInt(Options.PLAYER_SAVESTATUSES,
			  (ceStatusSaveC.getState() * ceStatusSaveP.getSelectedKey()));
	Base.putOptionInt(Options.PLAYER_FORWARDSTEP,seForwardStep.getSelectedKey());

	Base.putOption(Options.PLAYER_PLAYLISTMEMORY, sePlm.getString());

	if (cePUpdate.getState()==1)
	{
	    Menu mnu = (Menu)getPrevious();
	    mnu.remakeMenu(true);
	}
	
	super.submit();
    }
    
}


