package inline;

import inline.ui.*;
import inline.sys.*;
import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import inline.ui.le.*;
import inline.ui.ce.*;

public class SetupU extends ListFormCanvas 
{
    private InPlayer player;
    private CheckElement ceAnimation;
    private ChoiceElement ceFlashOff;
    private ChoiceElement ceLanguage;
    private FigureElement feLockSetup;
    private FigureElement feColors;
    
    public SetupU(InPlayer pplayer, HostCanvas pprevious)
    {
	super(pprevious, Base.getText(0x0402), Base.getText(0x0504), Base.getText(0x0505));
	player = pplayer;
	
	ceAnimation = new CheckElement(Base.getText(0x0431),CheckElement.TYPE_2);
	ceAnimation.setState(Base.getOptionIntDefault(CANVAS_ANIMATION,0));
	
	String sec = Base.getText(0x0451);
	String min = Base.getText(0x0452);
	
	String[] fos = {Base.getText(0x0453), "5 "+sec, "15 "+sec, "30 "+sec, "1 "+min, "2 "+min, "5 "+min};
	int[] fop = {0,5,15,30,60,120,300};
	ceFlashOff = new ChoiceElement(Base.getText(0x0432),
					    fos,
					    fop,
					    Base.getOptionIntDefault(CANVAS_FLASHOFF,30));
	
	String[] lgs = {Base.getText(0x0435),
			Base.getText(0x0436), 
			Base.getText(0x0437)};

	int[] lgp = {0, Globalization.ENGLISH_LCID, Globalization.RUSSIAN_LCID};

	ceLanguage = new ChoiceElement(Base.getText(0x0434),
					    lgs,
					    lgp,
					    Base.getOptionIntDefault(Options.LCID, 0));

	feLockSetup = new FigureElement(Base.getText(0x0438), CanvasElement.FIGURE_RARROW);
	feColors = new FigureElement(Base.getText(0x0433), CanvasElement.FIGURE_RARROW);
	
	Vector vct = new Vector();
	vct.addElement(feColors);
	vct.addElement(feLockSetup);
	vct.addElement(ceAnimation);
	vct.addElement(ceFlashOff);
	vct.addElement(ceLanguage);

	list.setLines(vct);
	list.setFastScroll(false);
    }

    public void selectPreview(Object obj)
    {
	super.selectPreview(obj);
	
	if (obj == feLockSetup)
	{
	    SetupLS sls = new SetupLS(this);
	    focus(sls);
	}
	else if (obj == feColors)
	{
	    SetupC scs = new SetupC(this);
	    focus(scs);
	}
	else if (obj instanceof SetupC)
	{
    	    getPrevious().updateColors();
	    player.updateColors();
	    updateColors();
	    repaint();
	}
    }
    
    protected void submit()
    {
	Base.putOptionInt(CANVAS_ANIMATION,ceAnimation.getState());
	Base.putOptionInt(CANVAS_FLASHOFF,ceFlashOff.getSelectedKey());
	
	int nlcid = ceLanguage.getSelectedKey();
	if (nlcid != Base.getOptionIntDefault(Options.LCID, 0))
	{
	    Globalization.setSystemLCID(nlcid);
	    Base.langRefresh();
	    Base.putOptionInt(Options.LCID, nlcid);
	}
	
	super.submit();
    }
    
}


