package inline.res;

import inline.res.*;
import inline.sys.*;

public class Language
{  

    private final static Integer[] langs = {new Integer(Globalization.ENGLISH_LCID), 
					   new Integer(Globalization.RUSSIAN_LCID)};
    private final static String[] table = 
	    
	    {"\u0000","Integral","Интеграл",
		 
	     "\u0100","Getting playlist...","Обновление списка...",
	     "\u0101","Saving playlist...","Сохранение списка...",
		 
	     "\u0201","Mark as new","Новый", //"mrsn"
	     "\u0202","Mark as played","Прослушанный", //"mrsp"
	     "\u0203","Mark all as new","Все новые", //"mran"
		 
	     "\u0211","File system of this device","Файловая система этого", //"fsn1"
	     "\u0212","is not supported","устройста не поддерживается", // "fsn2"
		 
	     "\u0401","Main menu","Главное меню", // "mnmm"
	     "\u0402","Interface options","Настройка интерфейса", // "mnou"
	     "\u0403","Player options","Настройка плейера", //"mnop"
	     "\u0404","Lock (*)","Заблокировать (*)", //"mnlc"
	     "\u0405","Reload playlist","Обновить список файлов", //"mnrp"
	     "\u0406","System log","Системный журнал", //"mnsl"
	     "\u0407","Quit","Выход", //"mnqt"

 	     "\u0411","About","О программе", //"mnab"
	     "\u0412","Inlined, 2006\nE-mail: "+'i'+'n'+"lined"+'@'+'n'+'m'+".ru", null, //"abtx"
	     "\u0413","http://integral.sf.net", null,

	     "\u0421","Shuffle","Случайный порядок", //"opsh"
	     "\u0422","With subdirectories","С подкаталогами", //"opws"
	     "\u0423","Modify extensions","Расширения файлов", //"opex"
	     "\u0424","Modify directories","Каталоги", //"opdr"
	     "\u0425","Playlist from file","Плейлист из файла", //"opml"
	     "\u0426","Playlist file:","Файл списка:", //"oppm"
	     "\u0427","Autostart playback","Автостарт", //"opas"
	     "\u0428","Background support","Фоновый режим", //"opbs"
	     "\u0429","Keep played statuses:","Сохранять статусы:",
	     "\u042B","Completely played","Полностью проигранные",
	     "\u042C","Partially","Частичные",
	     "\u042D","Don't save","Не сохранять",
	     "\u042E","Only last","Последний",
	     "\u042F","Save all","Все",
	     "\u0430","Forward step","Шаг перемотки",
		 
	     "\u0431","Animation","Анимация", //"ouan"
	     "\u0432","Backlight timeout","Подсветка", //"oubt"
	     "\u0433","Color scale","Цветовая гамма", //"oucs"
	     "\u0434","Language","Язык", //"oulg"
	     "\u0435","Auto","Автоматически", //"oula"
	     "\u0436","English","Английский", //"oule"
	     "\u0437","Russian","Русский", //"oulr"
	     "\u0438","Lock screen","Экран блокировки", //"oulc"

	     "\u0441","Text color","Цвет текста", //"cstx"
	     "\u0442","Middle color","Средний цвет", //"csmd"
	     "\u0443","Background color","Цвет фона", //"csbg"
	     "\u0444","Apply","Применить",
	     "\u0445","Schemes","Схемы",
	     "\u0446","Colors","Цвета",
	     "\u0447","Random","Случайно",
		 
	     "\u0451","sec","сек", //"tsec"
	     "\u0452","min","мин", //"tmin"
	     "\u0453","Off","Всегда", //"toff"
		 
	     "\u0461", "Red", "Красный", //"cred"
	     "\u0462", "Green", "Зеленый", //"cgrn"
	     "\u0463", "Blue", "Синий", //"cblu"
		  
	     "\u0501", "Ok", "Ок", //"geok"
	     "\u0502", "Cancel", "Отмена", //"geca"
	     "\u0503", "Off", "Нет", //"geof"
	     "\u0504", "Save", "Сохранить", //"save"
	     "\u0505", "Back", "Назад", //"back"
	     
	     "\u0601", "Add...", "Добавить...", //"sead"
	     "\u0602", "Add copy...", "Добавить копию...", //"seac"
	     "\u0603", "Edit...", "Редактировать...", //"seed"
	     "\u0604", "Delete", "Удалить", //"sede"
	     "\u0605", "Text input", "Ввод текста", //"tett"

	     "\u0701", "Next (8)","Следующий (8)", //"lsnx"
	     "\u0702", "Stop/start (0)","Стоп/старт (0)", //"lsst"
	     "\u0703", "Unlock (*)","Разблокировать (*)", //"lsun"
	     "\u0704", "Clock with seconds","Часы с секундами", //"lsse"
	     "\u0705", "Auto-lock","Автоблокировка", //"lsal"
	     "\u0706", "Color","Цвет", //"lscl"
	     "\u0707", "Black on white","Белый на черном", //"lscb"
	     "\u0708", "White on black","Черный на белом", //"lscw"
	     "\u0709", "Don't change","Не менять", //"lscn"
		 
	     "\u0801", "Track information","Информация о тэгах", //"titt"
		 
	     "\u6000", "Sahara", "Сахара",
	     "\u6001", "Flamingo", "Фламинго",
	     "\u6002", "Blue gull", "Синяя чайка",
	     "\u6003", "Nightly build", "Ночная сборка",
	     "\u6004", "Chocolate", "Шоколад",
	     "\u6005", "Rainforest", "Тропики",
	     "\u6006", "Velveteen", "Вельвет",
	     "\u6007", "Terminal", "Терминал",
	     "\u6008", "Antarctica", "Антарктида", 
	     "\u6009", "Early fall", "Ранняя осень",   
	     "\u600a", "Silver", "Серебро"
    
	    };
	   
	    
    public final static void make(SerialHashtable sht)
    {
	sht.put("_langs", langs);
	sht.put("_lngtbl", table);
    }
}



