/*
 * This one's proxy for all static (system) methods, like options, fs and so on
 *
 */

package inline.sys;

import java.util.*;
import java.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import inline.*;
import inline.fs.*;

public class Base  
{
    private static MIDlet midlet;
    private static Display display;
    private static Options options;
    private static Globalization glob;

    public static void startup(MIDlet mmidlet)
    {
	midlet = mmidlet;
	display = Display.getDisplay(midlet);

	options = new Options();
	options.load();
	
//System.err.println(options);	
	
	InputStream is = midlet.getClass().getResourceAsStream("/res.sht");
	options.loadFromInputStream(is); // this one is null-safe
	
	Globalization.setSystemLCID(options.getIntDefault(options.LCID, 0));
	glob = new Globalization();
	langRefresh();
    }

    public static void goodbye()
    {
	midlet.notifyDestroyed();
    }
    
    public static String getVersion()
    {
	return midlet.getAppProperty("MIDlet-Version");
    }
    
    public static void setCurrentDisplay(Displayable displayable)
    {
	display.setCurrent(displayable);
    }
    
    public static void callDisplaySerially(Runnable runner)
    {
	display.callSerially(runner);
    }
    
    public static Object getOption(Object obj)
    {
	return options.get(obj);
    }
    
    public static int getOptionIntDefault(String key, int def)
    {
	return options.getIntDefault(key, def);
    }
    
    public static Object putOption(Object obj, Object value)
    {
	return options.put(obj, value);
    }

    public static void putOptionInt(String key, int value)
    {
	options.putInt(key, value);
    }
    
    public static void saveOptions()
    {
	options.save();
    }
    
    public static boolean flashBacklight(int time)
    {
	return display.flashBacklight(time);
    }

    public static void langRefresh()
    {
        Integer[] lngs = (Integer[])options.get("_langs");
	String[] tbl = (String[])options.get("_lngtbl");
	glob.remap(lngs, tbl);
    }

    public static String getText(int code)
    {
	return glob.take(code);
    }

    public static void sortStringArray(String[] strArray)
    {
	String tmp;
	if (strArray == null || strArray.length <= 1) return;
	
	for (int i = 0; i < strArray.length; i++)
	{
	    for (int j = i + 1; j < strArray.length; j++)
	    {
		if( strArray[i].compareTo(strArray[j]) > 0 )
		{
		    tmp = strArray[i];
		    strArray[i] = strArray[j];
		    strArray[j] = tmp;
		}
	    }
	}
    }    
    
}


