package inline.ui;

import java.util.*;
import javax.microedition.lcdui.*;
import inline.ui.ce.InList;
import inline.ui.ce.Figure;
import inline.ui.ce.Label;
import inline.sys.*;
import inline.ui.lo.*;

public class ListFormCanvas extends HostCanvas 
{
    protected InList list;
    private Label lOK;
    private Label lCancel;

    public ListFormCanvas(HostCanvas previous, String ccaption, String leftsoftname, String rightsoftname)
    {
        setFullScreenMode(true);
	setPrevious(previous);
	
	Panel mil = getLayoutManager().addPane(Panel.ALIGN_TOP);

	Label tlabel = new Label(this, ccaption);
	tlabel.setAlign(tlabel.CENTER);
	tlabel.hasBorder(true);
	addElement(tlabel, mil);

	Panel bil = getLayoutManager().addPane(Panel.ALIGN_BOTTOM);

	lOK = new Label(this, leftsoftname);
	lOK.hasBorder(true);
	lOK.setAlign(tlabel.CENTER);
	lOK.setAccelerator(lOK.LEFT_SOFT);
	addElement(lOK,bil);

	Figure fml = new Figure(this);
	fml.hasBorder(true);  
	fml.setVisible(false);
	fml.setFigure(fml.FIGURE_MENU);
	addElement(fml, bil, fml.getFontHeight(),0);
	menulabel = fml;
	
	lCancel = new Label(this, rightsoftname);
	lCancel.hasBorder(true);
	lCancel.setAlign(tlabel.CENTER);
	lCancel.setAccelerator(lCancel.RIGHT_SOFT);
	addElement(lCancel,bil);

	Panel cli = getLayoutManager().addPane(Panel.ALIGN_CLIENT);

	list = new InList(this);
//	list.hasBorder(true);
        addElement(list, cli);

	focus(list);
    }
    
    public ListFormCanvas(HostCanvas previous, String ccaption)
    {
	this(previous, ccaption, Base.getText(0x0501),Base.getText(0x0502));
    }

    public void selectPreview(Object obj)
    {
	super.selectPreview(obj);
	
	if (obj instanceof Label)
	{
	    if (obj == lOK  && lOK.getCaption().compareTo("")!=0)
	    {
		submit();
		goBack(true);
	    }
	    else if (obj == lCancel && lCancel.getCaption().compareTo("")!=0)
	    {
		goBack(false);
	    }
	}
    }
    
    protected void submit()
    {
    }
}



