package inline.ui;

import java.util.*;
import javax.microedition.lcdui.*;
import inline.ui.ce.*;
import inline.ui.lo.*;
import inline.sys.*;

public class WaitingCanvas extends HostCanvas implements Runnable
{
    protected static final int GEOCENTERT = 20;
    
    private HostCanvas next;
    private Thread runner;
    
    private Label lCaption;
    private Label lOperation;
    private Figure fAnimation;
    private SpaceField sfNet;

    public WaitingCanvas(Thread tthread)
    {
        setFullScreenMode(true);
	runner = tthread;
        next = null;

	int lx = GEOCENTERT<<1;
	int fnthei = Font.getDefaultFont().getHeight();

	lCaption = new Label(this,lx,lx,getWidth()-lx,fnthei,"");
	lOperation = new Label(this,lx,lx+20,getWidth()-lx,fnthei,"");
	fAnimation = new Figure(this,0,GEOCENTERT,lx,lx,   
				Figure.FIGURE_NEBULA1+(new Random().nextInt()&3));
	
	Panel bil = getLayoutManager().addPane(Panel.ALIGN_BOTTOM);

	sfNet = new SpaceField(this);
	//sfNet.hasBorder(true);
	addElement(sfNet, bil, 0,120);
	
	addElement(lCaption);
	addElement(lOperation);  
	addElement(fAnimation);  

	setAmination();
    }
    
    public void setAmination()
    {
        int anime = Base.getOptionIntDefault(CANVAS_ANIMATION,0);
        if (anime==1)
        {
	    fAnimation.setAnimated( fAnimation.FIGURE_NEBULA4,
	    			    fAnimation.FIGURE_NEBULA1, 
					50);
		
	    fAnimation.setRatio(75+(new Random().nextInt()%20),
				    40, 95, 
				    new Random().nextInt()%9);
	}
        else
        {
	    fAnimation.setRatio(85+(new Random().nextInt()%10), 0, 0, 0);
	}
    }

    public void perform(HostCanvas cnext)
    {
        next = cnext;
	
        focus();
        Base.callDisplaySerially(this);
    }

    public void setCaption(String name)
    {
	lCaption.setCaption(name);
    }
    
    public void setOperation(String name)
    {
	lOperation.setCaption(name);
    }

    public Thread getRunner()
    {
	return runner;
    }
    
    public void run() 
    {
	runner.start();
    }

    public void selectPreview(Object obj)
    {
	super.selectPreview(obj);
	
	if (obj == runner)
	{
	    // we've finished
	    next.selectPreview(this);
	    Base.setCurrentDisplay(next);
	}
    }
    
}

