package inline.ui.ce;

import inline.ui.*;
import java.util.*;
import javax.microedition.lcdui.*;

    public class ColorRamp extends CanvasElement 
    {
	private int rampa;
	private int rampb;
	private boolean drawmarks; 
	
        public ColorRamp(HostCanvas prnt, int x, int y, int w, int h)
        {
            super(prnt, x,y,w,h);
	    setRamp(0, 100);
        }
        
        public ColorRamp(HostCanvas prnt)
        {
            this(prnt, 0,0,0,0);
        }

	public void drawMarks(boolean flag)
	{
	    drawmarks = flag;
	}
	
	public void paintElement(Graphics g) 
        {
            synchronized (g) 
            {
		paintDeeply(g);
            }
        }
        
	public void setRamp(int ra, int rb)
	{
	    rampa = ra;
	    rampb = rb;
	}
	
	private void paintDeeply(Graphics g) 
        {
	    int STEPS = 24;
	    for(int i=0;i<STEPS;i++)
	    {
		g.setColor(getRampColor(rampa+(STEPS-i)*(rampb-rampa)/(STEPS)));
		
		int ya = getHeight()*(i)/STEPS;
		int yb = getHeight()*(i+1)/STEPS;
		
		g.fillRect(0, ya, getWidth(), yb-ya);
	    }

	    if (drawmarks)
	    {
		drawMark(g, 2);
		drawMark(g, (getHeight()>>1)-4);
		drawMark(g, getHeight()-10);
	    }
	}
	
	private void drawMark(Graphics g, int y)
	{
	    g.setColor(0xffffff);
	    int bx = getWidth() - 2;
	    g.fillTriangle(bx, y, bx,  y+8, bx-8,  y+4);
	    g.setColor(0x0);
	    g.fillTriangle(bx-1, y+2, bx-1,  y+6, bx-6,  y+4);
	}

    }





