package inline.ui.ce;

import inline.ui.*;
import java.util.*;
import javax.microedition.lcdui.*;


    public class Label extends CanvasElement 
    {
        protected String caption;
	public final static int LEFT = 0;
	public final static int CENTER = 1;
	public final static int RIGHT = 2;

	private int align = LEFT;

        public Label(HostCanvas prnt, int x, int y, int w, int h, String ccaption)
        {
            super(prnt, x,y,w,h);
            setCaption(ccaption);
	    setStyleable(true);
        }
        
        public Label(HostCanvas prnt, String ccaption)
        {
            this(prnt, 0,0,0,0, ccaption);
        }

	public void paintElement(Graphics g) 
        {
            synchronized (g) 
            {
		if (align == LEFT)
		{
		    paintStringASC(this, g, caption, 0, 0, 0, 0, getAutoScrollCounter());
		}
		else if (align == CENTER)
		{
		    g.drawString(caption, getWidth()>>1, 0, Graphics.TOP|Graphics.HCENTER);
		}
		else if (align == RIGHT)
		{
		    g.drawString(caption, getWidth()-1, 0, Graphics.TOP|Graphics.RIGHT);
		}
            }
        }
        
	public void setCaption(String ccaption)
	{
	    if (ccaption==null) ccaption = "";
            caption = ccaption;
	    clearAutoScrollCounter();
	    repaint();
	}

	public String getCaption()
	{
            return caption;
	}

	public void setAlign(int aalign)
	{
            align = aalign;
	}

	protected int getContentWidthImpl()
	{
	    return getFont().stringWidth(caption); 
	}

	protected int getContentHeightImpl()
	{
	    return getFontHeight(); 
	}
    }


