package inline.ui.ce;

import inline.ui.*;
import java.util.*;
import javax.microedition.lcdui.*;


    public class Progress extends CanvasElement 
    {
        private int curpos = 0;
        private int minpos = 0;
        private int maxpos = 0;

        public Progress(HostCanvas prnt, int x, int y, int w, int h)
        {
            super(prnt, x,y,w,h);
            curpos = 0;
	    minpos = 0;
	    maxpos = 100;
        }
        
        public Progress(HostCanvas prnt)
        {
            this(prnt, 0,0,0,0);
        }

	public void paintElement(Graphics g) 
        {
            synchronized (g) 
            {
		int fw = curpos*(getWidth())/(maxpos-minpos);
		g.fillRect(0,0, fw, getHeight());
            }
        }
        
	public void setRange(int min, int max)
	{
	    minpos = min;
	    maxpos = max;
	}

	public void setPosition(int pos)
	{
	    curpos = pos;
	    repaint();
	}

    }



