package inline.ui.le;

import javax.microedition.lcdui.*;
import inline.ui.ce.CanvasElement;

    public class FigureElement extends StringElement
    {
	protected int figure;
        
        public FigureElement(String txt, int ffigure)
        {
	    super(txt);
	    setFigure(ffigure);
        }
        
	public boolean ownerDraw()
	{
	    return true;
	}
	
	public void onDraw(Graphics g, inline.ui.ce.InList lst, int x, int y, int asc ) 
	{
	    int fh = lst.getFontHeight();
	    int d1 = (fh >> 2);
	    int d2 = (fh >> 1);

	    boolean sel = (asc>=0);
	    
	    g.setColor(lst.getRampColor(80, sel));
	    lst.execMetaCommands(g, figure, x, y, fh, fh);

	    g.setColor(lst.getRampColor(100, sel));
	    g.drawString(text, x+fh, y, 0);
	}
	

	public void setFigure(int ffigure)
	{
	    figure = ffigure;
	}

	public int getFigure()
	{
	    return figure;
	}

	public boolean keyPressedElement(int keyCode, CanvasElement parent)
	{
	    if (keyCode == CanvasElement.RIGHT && figure==parent.FIGURE_RARROW)
	    {
		parent.getParent().selectPreview(this);
	    }
		    
	    return false;
	}
    
	public boolean deliverKeys()
	{
	    return true;
	}
    }


